Unit aer7e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure aer7e(NM :Integer; N :Integer; var AR :Array of Extended;
                var AI :Array of Extended; var D :Array of Extended;
                var E :Array of Extended; var E2 :Array of Extended;
                var TAU :Array of Extended);

implementation

procedure aer7e(NM :Integer; N :Integer; var AR :Array of Extended;
                var AI :Array of Extended; var D :Array of Extended;
                var E :Array of Extended; var E2 :Array of Extended;
                var TAU :Array of Extended);
var
I,J,K,L,II,JP1 :Integer;
F,FI,G,GI,H,HH,SI,SCALE :Extended;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16;
begin
TAU[0+(N-1)*2] := 1.0e0;
TAU[1+(N-1)*2] := 0.0e0;
for I:=1 to N do
 begin
_1:
  D[I-1] := AR[(I-1)+(I-1)*NM];
 end;
{  ********** }
for II:=1 to N do
 begin
  I := N+1-II;
  L := I-1;
  H := 0.0e0;
  SCALE := 0.0e0;
  if ( L < 1 ) 
   then goto _3;
{  ********** }
  for K:=1 to L do
   begin
_2:
    SCALE := SCALE+Abs(AR[(I-1)+(K-1)*NM])+Abs(AI[(I-1)+(K-1)*NM]);
   end;
  if ( SCALE <> 0.0e0 ) 
   then goto _4;
  TAU[0+(L-1)*2] := 1.0e0;
  TAU[1+(L-1)*2] := 0.0e0;
_3:
  E[I-1] := 0.0e0;
  E2[I-1] := 0.0e0;
  goto _15;
_4:
  for K:=1 to L do
   begin
    AR[(I-1)+(K-1)*NM] := AR[(I-1)+(K-1)*NM]/SCALE;
    AI[(I-1)+(K-1)*NM] := AI[(I-1)+(K-1)*NM]/SCALE;
    H := H+AR[(I-1)+(K-1)*NM]*AR[(I-1)+(K-1)*NM]+AI[(I-1)+(K-1)*NM]*AI[(I-1)+(K-1)*NM];
_5:
   end;
  E2[I-1] := SCALE*SCALE*H;
  G := Sqrt(H);
  E[I-1] := SCALE*G;
  F := Cabs(Cmplx(AR[(I-1)+(L-1)*NM],AI[(I-1)+(L-1)*NM]));
{  ******** }
  if ( F = 0.0e0 ) 
   then goto _6;
  TAU[0+(L-1)*2] := (AI[(I-1)+(L-1)*NM]*TAU[1+(I-1)*2]-AR[(I-1)+(L-1)*NM]*TAU[0+(I-1)*2])/F;
  SI := (AR[(I-1)+(L-1)*NM]*TAU[1+(I-1)*2]+AI[(I-1)+(L-1)*NM]*TAU[0+(I-1)*2])/F;
  H := H+F*G;
  G := 1.0e0+G/F;
  AR[(I-1)+(L-1)*NM] := G*AR[(I-1)+(L-1)*NM];
  AI[(I-1)+(L-1)*NM] := G*AI[(I-1)+(L-1)*NM];
  if ( L = 1 ) 
   then goto _13;
  goto _7;
_6:
  TAU[0+(L-1)*2] := -TAU[0+(I-1)*2];
  SI := TAU[1+(I-1)*2];
  AR[(I-1)+(L-1)*NM] := G;
_7:
  F := 0.0e0;
  for J:=1 to L do
   begin
    G := 0.0e0;
    GI := 0.0e0;
{  ********** }
    for K:=1 to J do
     begin
      G := G+AR[(J-1)+(K-1)*NM]*AR[(I-1)+(K-1)*NM]+AI[(J-1)+(K-1)*NM]*AI[(I-1)+(K-1)*NM];
      GI := GI-AR[(J-1)+(K-1)*NM]*AI[(I-1)+(K-1)*NM]+AI[(J-1)+(K-1)*NM]*AR[(I-1)+(K-1)*NM];
_8:
     end;
    JP1 := J+1;
    if ( L < JP1 ) 
     then goto _10;
    for K:=JP1 to L do
     begin
      G := G+AR[(K-1)+(J-1)*NM]*AR[(I-1)+(K-1)*NM]-AI[(K-1)+(J-1)*NM]*AI[(I-1)+(K-1)*NM];
      GI := GI-AR[(K-1)+(J-1)*NM]*AI[(I-1)+(K-1)*NM]-AI[(K-1)+(J-1)*NM]*AR[(I-1)+(K-1)*NM];
_9:
     end;
{  ********* }
_10:
    E[J-1] := G/H;
    TAU[1+(J-1)*2] := GI/H;
    F := F+E[J-1]*AR[(I-1)+(J-1)*NM]-TAU[1+(J-1)*2]*AI[(I-1)+(J-1)*NM];
_11:
   end;
  HH := F/(H+H);
{  ********** }
  for J:=1 to L do
   begin
    F := AR[(I-1)+(J-1)*NM];
    G := E[J-1]-HH*F;
    E[J-1] := G;
    FI := -AI[(I-1)+(J-1)*NM];
    GI := TAU[1+(J-1)*2]-HH*FI;
    TAU[1+(J-1)*2] := -GI;
    for K:=1 to J do
     begin
      AR[(J-1)+(K-1)*NM] := AR[(J-1)+(K-1)*NM]-F*E[K-1]-G*AR[(I-1)+(K-1)*NM]+FI*TAU[1+(K-1)*2]+GI*AI[(I-1)+(
    K-1)*NM];
      AI[(J-1)+(K-1)*NM] := AI[(J-1)+(K-1)*NM]-F*TAU[1+(K-1)*2]-G*AI[(I-1)+(K-1)*NM]-FI*E[K-1]-GI*AR[(I-1)+(
    K-1)*NM];
_12:
     end;
   end;
_13:
  for K:=1 to L do
   begin
    AR[(I-1)+(K-1)*NM] := SCALE*AR[(I-1)+(K-1)*NM];
    AI[(I-1)+(K-1)*NM] := SCALE*AI[(I-1)+(K-1)*NM];
_14:
   end;
  TAU[1+(L-1)*2] := -SI;
_15:
  HH := D[I-1];
  D[I-1] := AR[(I-1)+(I-1)*NM];
  AR[(I-1)+(I-1)*NM] := HH;
  AI[(I-1)+(I-1)*NM] := SCALE*Sqrt(H);
_16:
 end;
end;

end.
